# -*- coding: iso-8859-15 -*-
#     file     : python/l_crc32.py
#     author   : Marcus Rickert
#     RCS      : $Id$
#     purpose  : provide specific CRC32 algorithm (most significant bit first)
#
#     Copyright (C) 2010 :  Marcus Rickert

# TODO:
#

# -----------------------------------------------------------------------------------

POLYNOM = 0x04C11DB7L

# -----------------------------------------------------------------------------------

def GetCRC32(data, startCode = 0xFFFFFFFF):
    crc32 = startCode
    for b in data:
        crc32 = GetCRC32_bit(ord(b), crc32)
    return crc32

# -----------------------------------------------------------------------------------

def GetCRC32_bit(data, crc32):
    for i in range(7, -1 ,-1):
        if ((data & (1 << i)) > 0) == ((crc32 & 0x80000000) > 0):
            crc32 = (crc32 << 1) & 0xFFFFFFFF
        else:
            crc32 = ((crc32 << 1) ^ POLYNOM) & 0xFFFFFFFF
    return crc32 & 0xFFFFFFFF

# -----------------------------------------------------------------------------------
